/*---------------------------------------------------------------------------*
  Project:  MicTest - sample2
  File:     cell.h

  Copyright 2003-2008 Nintendo. All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law. They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

 *---------------------------------------------------------------------------*/

#ifndef CELL_H
#define CELL_H

#include <nnsys/g2d/fmt/g2d_Cell_data.h>
/*-----------------------------------------------------------------------*
                    Declarations of types and constants
 *-----------------------------------------------------------------------*/
typedef struct
{
    s16  x;
    s16  y;
    int  num;
    const NNSG2dCellData*  celldata;
}
cell;

enum
{
    GE_MAIN,
    GE_SUB,
    GE_BOTH
};

/*-----------------------------------------------------------------------*
                    Global variable definitions
 *-----------------------------------------------------------------------*/

/*-----------------------------------------------------------------------*
                    Declarations external to functions
 *-----------------------------------------------------------------------*/
void Cell_SetCellData(const char *, const int );
void Cell_UnloadCellFiles(const int);
const NNSG2dCellData* RetCellData(const u16 , const s16 );
int  SetCellDataToOAM(GXOamAttr* , const cell* );

#endif
