/*---------------------------------------------------------------------------*
  Project:  MicTest - sample2
  File:     file.c

  Copyright 2003-2008 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

 *---------------------------------------------------------------------------*/

#include "file.h"
#include "memory.h"

void* LoadFile(const char* fpath)
{
    u32    read, length;
    FSFile file;
    void*  tmp;
    BOOL   tbool;

    SDK_NULL_ASSERT( fpath );
    FS_InitFile(&file);

    tbool = FS_OpenFile(&file, fpath);
    if (!tbool)
    {
        OS_Panic("file=%s",fpath);
    }
    
    read = FS_GetLength(&file);
    SDK_ASSERT(read != 0);

    tmp = mem_alloc(read, 4);
    SDK_NULL_ASSERT( tmp );
    length = (u32)FS_ReadFile(&file, tmp, (s32)read);

    SDK_ASSERT(length == read);
    SDK_ASSERT(length > 0 );

    tbool = FS_CloseFile(&file);
    SDK_ASSERT( tbool == TRUE );

    return tmp;
}
