/*---------------------------------------------------------------------------*
  Project:  MicTest - sample2
  File:     memory.c

  Copyright 2003-2008 Nintendo. All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law. They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

 *---------------------------------------------------------------------------*/

//------------------------------------------------------------
#include "memory.h"

//------------------------------------------------------------
NNSFndHeapHandle       gHeapHandle;      // the heap handle

//------------------------------------------------------------
void mem_init()
{
    u32   arenaLow      = MATH_ROUNDUP  ((u32)OS_GetMainArenaLo(), 16);
    u32   arenaHigh     = MATH_ROUNDDOWN((u32)OS_GetMainArenaHi(), 16);
    u32   heapSize      = arenaHigh - arenaLow;
    void* heapMemory    = OS_AllocFromMainArenaLo(heapSize, 16);

    gHeapHandle = NNS_FndCreateExpHeap(heapMemory, heapSize);
    SDK_ASSERT( gHeapHandle != NNS_FND_HEAP_INVALID_HANDLE );
}

//------------------------------------------------------------
void* mem_alloc(const u32 size, const int align)
{
    void* tmp;

    SDK_ASSERT( size > 0 );
    tmp = NNS_FndAllocFromExpHeapEx(gHeapHandle, size, align);
    SDK_ASSERT( tmp );
    return tmp;
}

//------------------------------------------------------------
void  mem_free(void* memBlock)
{
    SDK_ASSERT( NNS_FndFindContainHeap(memBlock) == gHeapHandle );
    NNS_FndFreeToExpHeap(gHeapHandle, memBlock);
}
