/*---------------------------------------------------------------------------*
  Project:  MicTest
  File:     MicTest.h

  Copyright 2003-2008 Nintendo. All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law. They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

 *---------------------------------------------------------------------------*/
#ifndef MIC_TEST_H_
#define MIC_TEST_H_

// Sampling rate
#define MICTEST_RATE   1000
// Sampling buffer cycle period (Corresponds to playback delay time)
#define MICTEST_TIME     32 /* msec */
#define MICTEST_SIZE  ((int)( MICTEST_RATE*MICTEST_TIME / 1000))

// For updating progress until the mic circuit stabilizes (300 msec interval)
#define  READY_UPDATE_TICKS     (OS_MilliSecondsToTicks(300))

/*---------------------------------------------------------------------------*
    Initialization

    Arguments:buffer - 32-bit aligned
 *---------------------------------------------------------------------------*/
void mictest_init(const void* buffer);

/*---------------------------------------------------------------------------*
    Start
 *---------------------------------------------------------------------------*/
void mictest_start(void);

/*---------------------------------------------------------------------------*
    Each frame
 *---------------------------------------------------------------------------*/
int  mictest_main(void);

/*---------------------------------------------------------------------------*
    Quit
 *---------------------------------------------------------------------------*/
void mictest_end(void);

/*---------------------------------------------------------------------------*
    Get the mic circuit status
 *---------------------------------------------------------------------------*/
u8  mictest_IsReady(void);

#endif//MIC_TEST_H_
